/*

    Bist: a chemical drawing tool
    Copyright (C) 2010 Valerio Benfante

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

class ChangeLayer: public bist_plugin{
public:
  ChangeLayer(immagine* image, string libpath);
  virtual ~ChangeLayer();
  
  virtual bool act(int e);
  
  
  virtual void register_plugin();
  virtual bool time_to_act();
  

  virtual bool need_atom();
  virtual bool need_leg();

  virtual string libpath();
  void inizialize();

  virtual std::string menu_path();

  void push_down(bool go_background=false);
  void push_up(bool go_foreground=false);
protected:

  bool _has_to_act;
  bool _has_acted;


};



extern "C" bist_plugin* create_plugin(immagine* imm, string libpath);
extern "C"  void destroy_plugin(bist_plugin* j);

